/****************************************************************************
**
** Copyright (C) 2009 Nokia Corporation and/or its subsidiary(-ies).
** All rights reserved.
** Contact: openBossa - INdT (renato.chencarek@openbossa.org)
**
** $QT_BEGIN_LICENSE:LGPL$
** No Commercial Usage
** This file contains pre-release code and may not be distributed.
** You may use this file in accordance with the terms and conditions
** contained in the Technology Preview License Agreement accompanying
** this package.
**
** GNU Lesser General Public License Usage
** Alternatively, this file may be used under the terms of the GNU Lesser
** General Public License version 2.1 as published by the Free Software
** Foundation and appearing in the file LICENSE.LGPL included in the
** packaging of this file.  Please review the following information to
** ensure the GNU Lesser General Public License version 2.1 requirements
** will be met: http://www.gnu.org/licenses/old-licenses/lgpl-2.1.html.
**
** In addition, as a special exception, Nokia gives you certain additional
** rights. These rights are described in the Nokia Qt LGPL Exception
** version 1.1, included in the file LGPL_EXCEPTION.txt in this package.
**
** If you have questions regarding the use of this file, please contact
** the openBossa stream from INdT (renato.chencarek@openbossa.org).
** $QT_END_LICENSE$
**
****************************************************************************/

#ifndef MAINVIEW_H
#define MAINVIEW_H

#include <QGraphicsView>
#include <QKeyEvent>
#include <QGraphicsScene>

#include "titlebar.h"
#include "citycarroussel.h"
#include "forecastdata.h"
#include "bootmanager.h"
#include "loading.h"
#include "citymanager.h"
#include "fakecontentscreen.h"

class MainView: public QGraphicsView
{
    Q_OBJECT

public:
    MainView(bool connected, QWidget *parent = 0);
    ~MainView();

protected:
    void keyPressEvent(QKeyEvent* event);

signals:
    void moveLeft();
    void moveRight();

private slots:
    void cityNameClicked();
    void closeCityManager();

    void pixmapLoaderIsIdle();
    void bootEnd();
    void startBoot();

private:
    QGraphicsScene m_scene;
    CityCarroussel *m_carroussel;
    Loading *m_loading;
    BootManager *m_bootManager;
    CityManager *m_manager;
    FakeContentScreen *m_fakeContentScreen;
    const bool m_connected;

    void showCarroussel();
    void createCityManager();
    void saveManagerList();
};

#endif // MAINVIEW_H

